/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of Manip.xs. Do not edit this file, edit Manip.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Manip.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

// declarations

int _bit_count (unsigned int value, int set);
int _bit_mask (unsigned int bits, int lsb);
int _bit_get (const unsigned int data, int msb, const int lsb);
int _bit_set (unsigned int data, int lsb, int bits, int value);
int _bit_tog (unsigned int data, int bit);
int _bit_on (unsigned int data, int bit);
int _bit_off (unsigned int data, int bit);

void __check_msb (int msb);
void __check_lsb (int msb, int lsb);
void __check_value (int value);

// definitions

int _bit_count (unsigned int value, int set){

    unsigned int bit_count;
    unsigned int c = 0;

    if (set){
        while (value != 0){
            c++;
            value &= value - 1;
        }
        bit_count = c;
    }
    else {
        int zeros = __builtin_clz(value);
        bit_count = (sizeof(int) * 8) - zeros;
    }

    return bit_count;
}

int _bit_mask (unsigned int bits, int lsb){
    return ((1 << bits) - 1) << lsb;
}

int _bit_get (const unsigned int data, int msb, const int lsb){

    __check_msb(msb);
    msb++; // we count from 1

    __check_lsb(msb, lsb);

    return (data & ((1 << msb) -1)) >> lsb;
}

int _bit_set (unsigned int data, int lsb, int bits, int value){

    __check_value(value);

    unsigned int value_bits = _bit_count(value, 0);

    if (value_bits != bits){
        value_bits = bits;
    }

    unsigned int mask = ((1 << value_bits) - 1) << lsb;

    data = (data & ~(mask)) | (value << lsb);

    return data;
}

int _bit_tog(unsigned int data, int bit){
    return data ^= 1 << bit;
}

int _bit_on(unsigned int data, int bit){
    return data |= 1 << bit;
}

int _bit_off(unsigned int data, int bit){
    return data &= ~(1 << bit);
}

void __check_msb (int msb){
    if (msb < 0)
        croak("\nbit_get() $msb param must be greater than zero\n\n");
}

void __check_lsb (int msb, int lsb){
    if (lsb < 0)
        croak("\nbit_get() $lsb param can not be negative\n\n");

    if (lsb + 1 > (msb))
        croak("\nbit_get() $lsb param must be less than or equal to $msb\n\n");
}

void __check_value (int value){
    if (value < 0)
        croak("\nbit_set() $value param must be zero or greater\n\n");
}


#line 113 "Manip.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 257 "Manip.c"

XS_EUPXS(XS_Bit__Manip__bit_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Bit__Manip__bit_count)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "value, set");
    {
	int	value = (int)SvIV(ST(0))
;
	int	set = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = _bit_count(value, set);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Bit__Manip__bit_mask); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Bit__Manip__bit_mask)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "bits, lsb");
    {
	int	bits = (int)SvIV(ST(0))
;
	int	lsb = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = _bit_mask(bits, lsb);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Bit__Manip__bit_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Bit__Manip__bit_get)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "data, msb, lsb");
    {
	int	data = (int)SvIV(ST(0))
;
	int	msb = (int)SvIV(ST(1))
;
	int	lsb = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = _bit_get(data, msb, lsb);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Bit__Manip__bit_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Bit__Manip__bit_set)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "data, lsb, bits, value");
    {
	int	data = (int)SvIV(ST(0))
;
	int	lsb = (int)SvIV(ST(1))
;
	int	bits = (int)SvIV(ST(2))
;
	int	value = (int)SvIV(ST(3))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = _bit_set(data, lsb, bits, value);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Bit__Manip__bit_tog); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Bit__Manip__bit_tog)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "data, bit");
    {
	int	data = (int)SvIV(ST(0))
;
	int	bit = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = _bit_tog(data, bit);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Bit__Manip__bit_on); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Bit__Manip__bit_on)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "data, bit");
    {
	int	data = (int)SvIV(ST(0))
;
	int	bit = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = _bit_on(data, bit);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Bit__Manip__bit_off); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Bit__Manip__bit_off)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "data, bit");
    {
	int	data = (int)SvIV(ST(0))
;
	int	bit = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	RETVAL = _bit_off(data, bit);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Bit__Manip); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Bit__Manip)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Bit::Manip::_bit_count", XS_Bit__Manip__bit_count);
        newXS_deffile("Bit::Manip::_bit_mask", XS_Bit__Manip__bit_mask);
        newXS_deffile("Bit::Manip::_bit_get", XS_Bit__Manip__bit_get);
        newXS_deffile("Bit::Manip::_bit_set", XS_Bit__Manip__bit_set);
        newXS_deffile("Bit::Manip::_bit_tog", XS_Bit__Manip__bit_tog);
        newXS_deffile("Bit::Manip::_bit_on", XS_Bit__Manip__bit_on);
        newXS_deffile("Bit::Manip::_bit_off", XS_Bit__Manip__bit_off);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

